/*
 	File:		DSP.h
 
 	Contains:	Constants for the Macintosh DSP API
 
 	Version:	Technology:	
 				Package:	Universal Interfaces  DDK v23c5.  Monday, May 15, 1995.
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/

#ifndef __DSP__
#define __DSP__


#ifdef __cplusplus
extern "C" {
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=mac68k
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#define kdspFIFOMaskAllMessages 0x00000000
#define kdspFIFOEnableOverUnderMessage 0x00000001
#define kdspFIFOEnableFullEmptyMessage 0x00000002
#define kdspFIFOEnableHighLowMessage 0x00000004
#define kdspFIFOEnableLinkMessage 0x00000008
#define kdspFIFOOverUnderTaskInactive 0x00000010
#define kdspFIFOFullEmptyTaskInactive 0x00000020
#define kdspAutoCache 0x00000000
#define kdspDemandCache 0x00000001
#define kdspOnChipSectionTable 0x00000004
#define kdspOnChipStack 0x00000020
#define kdspOffChipStack 0x00000040
#define kdspLumpyModule 0x00000000
#define kdspSmoothModule 0x00000001
#define kdspLeaveSection 0x00000000
#define kdspLoadSection 0x00000001
#define kdspSaveSection 0x00000002
#define kdspClearSection 0x00000004
#define kdspSaveOnContextSwitch 0x00000008
#define kdspExternal 0x00000000
#define kdspBankA 0x00000020
#define kdspBankB 0x00000040
#define kdspAnyBank (kdspBankA | kdspBankB)
#define kdspStaticSection 0x00000080
#define kdspFIFOSection 0x00000100
#define kdspReservedSectionFlag0200 0x00000200
#define kdspReservedSectionFlag0400 0x00000400
#define kdspReservedSectionFlag0800 0x00000800
#define kdspReservedSectionFlag1000 0x00001000
#define kdspReservedSectionFlag2000 0x00002000
#define kdspReservedSectionFlag4000 0x00004000
#define kdspReservedSectionFlag8000 0x00008000
#define kdspNotIOBufferSection 0x00010000
#define kdspInputBuffer 0x00020000
#define kdspOutputBuffer 0x00040000
#define kdspReservedSectionFlag80000 0x00080000
#define kdspScalableSection 0x00100000
#define kdspReservedSectionFlag200000 0x00200000
#define kdspDSPUseOnly 0x00400000
#define kdspNonData 0x00000000
#define kdsp3200Float 0x00000001
#define kdspIEEEFloat 0x00000002
#define kdspInt32 0x00000003
#define kdspInt1616 0x00000004
#define kdspInt8888 0x00000005
#define kdspmuLaw 0x00000006
#define kdspALaw 0x00000007
#define kdspAppSpecificData 0x0000FFFF
#define kdspHeadInsert 0x00000004
#define kdspTailInsert 0x00000008
#define kdspBeforeInsert 0x00000010
#define kdspAfterInsert 0x00000020
#define kdspAnyPositionInsert kdspHeadInsert
#define kdspBIOPinChangedState 0x62696f70
#define kdspFIFOMessage 0x66000000
#define kdspFIFOLinkMessage 0x666c6e6b
#define kdspFIFOOverrunMessage 0x666f7672
#define kdspFIFOUnderrunMessage 0x66756e64
#define kdspFIFOFullMessage 0x6666756c
#define kdspFIFOEmptyMessage 0x66656d70
#define kdspFIFOHighMessage 0x66686967
#define kdspFIFOLowMessage 0x666c6f77
#define kdspFIFOPrimeMessage 0x66707269
#define kdspExceptionMessage 0x78000000
#define kdspExceptionReset 0x78727374
#define kdspExceptionBusError 0x78627573
#define kdspExceptionIllegalOpcode 0x78696c6c
#define kdspExceptionReservedOne 0x78727631
#define kdspExceptionAddressError 0x78616472
#define kdspExceptionDAUOverUnderflow 0x78646175
#define kdspExceptionNotANumber 0x786e616e
#define kdspExceptionReservedTwo 0x78727632
#define kdspExceptionExternalIntZero 0x78657830
#define kdspExceptionTimer 0x7874696d
#define kdspExceptionReservedThree 0x78727633
#define kdspExceptionSIOInputBufFull 0x78736962
#define kdspExceptionSIOOutputBufEmpty 0x78736f62
#define kdspExceptionSIODMAInputFrame 0x78736966
#define kdspExceptionSIODMAOutputFrame 0x78736f66
#define kdspExceptionExternalIntOne 0x78657831
#define kdspExceptionRuntimeError 0x78657272
#define kdspGPBMessage 0x67000000
#define kdspGPBTaskActive 0x67616374
#define kdspGPBTaskInactive 0x67696e61
#define kdspGPBFrameOverrun 0x676f7672
#define kdspGPBFrameSkip 0x67736b70
#define kdspWritePermission 0x0001
#define kdspReadPermission 0x0002
#define kdspReadWritePermission (kdspWritePermission|kdspReadPermission)
#define kdsp3210 '3210'
#define kdspDeviceFeatures 'feat'
#define kdspDeviceName 'dnam'
#define kdspDeviceICON 'dicn'
#define kdspSlotNumber 'dslt'
#define kdspProcessorType 'ptyp'
#define kdspPhaseRegister 'phas'
#define kdspPhaseRollover 'phro'
#define kdspFrameRate 'fmrt'
#define kdspIODeviceName 'ionm'
#define kdspIODeviceICON 'ioic'
#define kdspBIOPinState 'bios'
#define kdspBIOPinDirection 'biod'
#define kdspBIOInterruptMask 'biom'
#define kdspBIOInterruptHandler 'bioh'
#define kdspSampleRate 'smrt'
#define kdspSampleFormat 'smsz'
#define kdspCurrentIndex -1
#define kdspMotherBoard 0
#define kdspCanBeSlaveCPUDevice 1
#define kdspCanOnlyAccessDSPZone 2
#define kdspSIOTypeDevice 0
#define kdspBIOTypeDevice 1
#define kdspStdSoundCompatible 0
#define kdspRegisterDSPOutputSifter 1
#define kdspInstallDSPInputDriver 2
#define kdspInputDriverOptionsDialogBox 3
#define kdspBIOPinZero (0)
#define kdspBIOPinOne (1)
#define kdspBIOPinTwo (2)
#define kdspBIOPinThree (3)
#define kdspBIOPinFour (4)
#define kdspBIOPinFive (5)
#define kdspBIOPinSix (6)
#define kdspBIOPinSeven (7)
#define kdspBIOConfigurePinForInput (0)
#define kdspBIOConfigurePinForOutput (1)
#define kdspBIOPinKeepCurrentState (0)
#define kdspBIOPinSetToZero (1)
#define kdspBIOPinSetToOne (2)
#define kdspBIOPinToggleCurrentState (3)
#define kevtMessageToHost (17)
#define kevtCacheSection (22)
#define kevtCopyFIFO (23)
#define kevtGetSectionSize (43)
#define kevtGPBSetUseActual (44)
#define kevtGPBExpectedCycles (45)
#define kevtGPBElapsedCycles (46)
#define kevtSemaphoreSet (47)
#define kevtSemaphoreClear (48)
#define kevtGPBChangeMode (49)
#define kevtSetSkipCount (50)
#define kevtSetTaskInactive (51)
#define kevtBlockMove (53)
#define kevtNumRealTimeFrames (113)
#define kdspUnimplemented (-2626)
#define kdspParamErr (-2638)
#define kdspNotAFIFOSection (-2634)
#define kdspNoMessageInterrupt (-2636)
#define kdspFIFOInUseByDSP (-2653)
#define kdspTaskMustBeInActive (-2654)
#define kdspNotFirstFIFO (-2655)
#define kdspPositionIllegalErr (-2600)
#define kdspPositionBusyErr (-2601)
#define kdspInvalidReferenceErr (-2602)
#define kdspNonExistantReferenceErr (-2603)
#define kdspNonExistantElementErr (-2604)
#define kdspMemFullErr (-2605)
#define kdspAddressNotInZone (-2606)
#define kdspNilAddress (-2617)
#define kdspContainingNilAddress (-2618)
#define kdspInvalidZoneSize (-2619)
#define kdspInvalidZoneBase (-2620)
#define kdspDeviceNotFound (-2607)
#define kdspInvalidIndexErr (-2608)
#define kdspDeviceHasActiveClients (-2609)
#define kdspInvalidPermission (-2622)
#define kdspWritePermissionDenied (-2623)
#define kdspClientNameInvalid (-2624)
#define kdspInvalidOptionSelector (-2625)
#define kdspInvalidIODeviceType (-2641)
#define kdspInvalidClientICON (-2651)
#define kdspDeviceCantBeSlave (-2662)
#define kdspModuleNotFound (-2610)
#define kdspModuleUncompatibleRate (-2611)
#define kdspUnknownDSPFResourceVersion (-2613)
#define kdspUnknownDSPSectionTag (-2614)
#define kdspZeroGPB (-2648)
#define kdspTwoStacks (-2665)
#define kdspStorageNotFound (-2629)
#define kdspNotEnoughOnChipMemory (-2630)
#define kdspCouldNotAllocate (-2612)
#define kdspMoreThanOneModule (-2621)
#define kdspSectionAlreadyConnected (-2627)
#define kdspSectionsDoNotMatch (-2628)
#define kdspSectionsNotInSameTask (-2640)
#define kdspSectionNotFound (-2631)
#define kdspBothFIFOsAllocated (-2632)
#define kdspHadToUseOffChipMemory (-2633)
#define kdspAlreadyAllocated (-2635)
#define kdspTooManyITBs (-2637)
#define kdspInvalidModuleAddress (-2646)
#define kdspAIAOMustLoadOrSave (-2649)
#define kdspFIFOsNotConnected (-2650)
#define kdspNotAllocated (-2652)
#define kdspTaskNotInstalled (-2666)
#define kdspTaskRefNumAlreadyAllocated (-2615)
#define kdspNilMessageActionProc (-2639)
#define kdspInvalidCPUDevicePtr (-2642)
#define kdspInvalidTaskRefNumPtr (-2643)
#define kdspInvalidTaskAddress (-2644)
#define kdspInvalidTaskRefNum (-2645)
#define kdspInvalidTaskName (-2647)
#define kdspNoMasterSlaveRelationship (-2656)
#define kdspAllTasksMustBeRealTime (-2657)
#define kdspNotEnoughTime (-2658)
#define kdspChangingState (-2659)
#define kdspAlreadyActive (-2660)
#define kdspAlreadyInactive (-2661)
#define kdspTimeOutErr (-2667)
#define kdspFrameOverrunRecoveryErr (-2668)
#define kdspNotEnoughGPB (-2616)
#define kdspOnChipPatchup (-2663)
#define kdspBadRelocationType (-2664)

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __DSP__ */
