/*
 	File:		DSPManager.h
 
 	Version:	Technology:	
 				Package:	Universal Interfaces  DDK v23c5.  Monday, May 15, 1995.
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/

#ifndef __DSPMANAGER__
#define __DSPMANAGER__


#ifdef __cplusplus
extern "C" {
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=mac68k
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif


#ifndef __TYPES__
#include <Types.h>
#endif
/*	#include <ConditionalMacros.h>								*/
#define kdspManagerBuildVersion 0x0000000D
typedef unsigned long DSPPosition;

typedef unsigned long DSPCycles;

typedef unsigned long DSPClientRefNum;

typedef unsigned long DSPIODeviceRefNum;

typedef unsigned long DSPCPUDeviceRefNum;

typedef unsigned long DSPTaskRefNum;

typedef unsigned long DSPModuleRefNum;

typedef unsigned long DSPSectionRefNum;

typedef unsigned long DSPFIFORefNum;

typedef unsigned long DSPLinkedFIFORefNum;

typedef unsigned long DSPSynchRefNum;

typedef pascal void (*MessageActionProc)(struct DSPMessage *theMessage);

enum DSPConnectionType {
	kdspDirectConnection,
	kdspIndirectConnection,
	kdspHIHOConnection
};

enum DSPTaskPriority {
	kdspRealTime,
	kdspTimeShare
};

enum DSPTaskStatus {
	kdspTaskIsActive,
	kdspTaskIsInactive,
	kdspTaskIsGoingInactive,
	kdspTaskIsGoingActive,
	kdspInvalidTask
};

typedef enum DSPTaskStatus DSPTaskStatus;
#ifndef __cplusplus
typedef struct DSPDeviceParamBlk DSPDeviceParamBlk;

typedef struct DSPCPUDeviceParamBlk DSPCPUDeviceParamBlk;

typedef struct DSPIODeviceParamBlk DSPIODeviceParamBlk;

typedef struct DSPBIODeviceParamBlk DSPBIODeviceParamBlk;

typedef struct DSPSIODeviceParamBlk DSPSIODeviceParamBlk;

typedef struct DSPFIFO DSPFIFO;

typedef struct DSPFIFOAddress DSPFIFOAddress;

typedef struct DSPMessage DSPMessage;

typedef struct DSPClientInfoParamBlk DSPClientInfoParamBlk;

typedef struct DSPTaskInfoParamBlk DSPTaskInfoParamBlk;

typedef struct DSPModuleInfoParamBlk DSPModuleInfoParamBlk;

typedef struct DSPSectionInfoParamBlk DSPSectionInfoParamBlk;

typedef struct DSPGPBModeIndicator DSPGPBModeIndicator;

typedef enum	DSPConnectionType		DSPConnectionType;
typedef enum	DSPTaskPriority			DSPTaskPriority;
#endif
struct DSPFIFOAddress {
	struct DSPFIFO					*l;
	struct DSPFIFO					*p;
};
#define DSPDeviceParamBlkHeader  \
	unsigned short	pbhDeviceIndex; \
	unsigned short	pbhClientPermission; \
	DSPClientRefNum	pbhClientRefNum; \
	Str31	pbhClientName;		\
	Handle	pbhClientICON;		\
	Str31	pbhDeviceName;		\
	Handle	pbhDeviceICON;
struct DSPDeviceParamBlk {
	unsigned short					pbhDeviceIndex;
	unsigned short					pbhClientPermission;
	DSPClientRefNum					pbhClientRefNum;
	Str31							pbhClientName;
	Handle							pbhClientICON;
	Str31							pbhDeviceName;
	Handle							pbhDeviceICON;
};
struct DSPCPUDeviceParamBlk {
	unsigned short					pbhDeviceIndex;
	unsigned short					pbhClientPermission;
	DSPClientRefNum					pbhClientRefNum;
	Str31							pbhClientName;
	Handle							pbhClientICON;
	Str31							pbhDeviceName;
	Handle							pbhDeviceICON;
	unsigned char					cpuSlotNumber;
	unsigned char					cpuProcessorNumber;
	OSType							cpuProcessorType;
	DSPCycles						cpuMaxCycles;
	DSPCycles						cpuAllocatedCycles;
	DSPCycles						cpuCurRealTimeLoading;
	DSPCycles						cpuTimeShareLoading;
	DSPCycles						cpuTimeShareFreq;
	Fixed							cpuFrameRate;
	MessageActionProc				cpuClientMessageActionProc;
	unsigned long					cpuClientRefCon;
};
struct DSPIODeviceParamBlk {
	unsigned short					pbhDeviceIndex;
	unsigned short					pbhClientPermission;
	DSPClientRefNum					pbhClientRefNum;
	Str31							pbhClientName;
	Handle							pbhClientICON;
	Str31							pbhDeviceName;
	Handle							pbhDeviceICON;
	unsigned short					iopbIODeviceIndex;
	unsigned short					iopbIODeviceType;
	unsigned char					iopbReserved[32];
};
struct DSPBIODeviceParamBlk {
	unsigned short					pbhDeviceIndex;
	unsigned short					pbhClientPermission;
	DSPClientRefNum					pbhClientRefNum;
	Str31							pbhClientName;
	Handle							pbhClientICON;
	Str31							pbhDeviceName;
	Handle							pbhDeviceICON;
	unsigned short					iopbIODeviceIndex;
	unsigned short					iopbIODeviceType;
	struct DSPMessage				*bioMessageHandler;
	unsigned char					bioPinState;
	unsigned char					bioPinDirection;
	unsigned char					bioPinIntEnable;
	unsigned char					bioReserved[25];
};
struct DSPSIODeviceParamBlk {
	unsigned short					pbhDeviceIndex;
	unsigned short					pbhClientPermission;
	DSPClientRefNum					pbhClientRefNum;
	Str31							pbhClientName;
	Handle							pbhClientICON;
	Str31							pbhDeviceName;
	Handle							pbhDeviceICON;
	unsigned short					iopbIODeviceIndex;
	unsigned short					iopbIODeviceType;
	Fixed							sioSampleRate;
	unsigned long					sioSampleFormat;
	DSPFIFOAddress					sioInputFIFO;
	DSPFIFOAddress					sioOutputFIFO;
	unsigned char					sioDMAEnable;
	unsigned char					sioFeatures;
	unsigned char					sioReserved[6];
};
struct DSPBandwidth {
	DSPCycles						bnEstimate;
	DSPCycles						bnActual;
	unsigned long					bnFlags;
};
struct DSPMessage {
	MessageActionProc				msVector;
	unsigned long					msData[3];
};
struct DSPGPBModeIndicator {
	unsigned short					miCurrentMode;
	unsigned short					miNextMode;
};
struct DSPClientInfoParamBlk {
	DSPClientRefNum					ciClientRefNum;
	unsigned short					ciClientPermission;
	Handle							ciClientICON;
	Str31							ciClientName;
};
struct DSPTaskInfoParamBlk {
	DSPTaskRefNum					tiRefNum;
	unsigned long					tiRefCon;
	MessageActionProc				tiVector;
	unsigned long					tiFlags;
	Str31							tiName;
};
struct DSPModuleInfoParamBlk {
	DSPModuleRefNum					miRefNum;
	struct DSPBandwidth				miGPB;
	unsigned long					miFlags;
	unsigned long					miNumSections;
	Str31							miName;
	unsigned long					miExecutions;
	unsigned long					miSkipCount;
};
struct DSPSectionInfoParamBlk {
	DSPSectionRefNum				siRefNum;
	unsigned long					siSize;
	unsigned long					siFlags;
	unsigned long					siType;
	Str31							siName;
	Ptr								siPrimary;
	Ptr								siSecondary;
	DSPSectionRefNum				siPrevSection;
	DSPSectionRefNum				siNextSection;
	DSPFIFORefNum					siFIFORefNum;
	Ptr								siPrimaryPhys;
	Ptr								siSecondaryPhys;
};
typedef DSPCPUDeviceParamBlk *DSPCPUDeviceParamBlkPtr, **DSPCPUDeviceParamBlkHandle;

typedef DSPIODeviceParamBlk *DSPIODeviceParamBlkPtr, **DSPIODeviceParamBlkHandle;

typedef DSPBIODeviceParamBlk *DSPBIODeviceParamBlkPtr, **DSPBIODeviceParamBlkHandle;

typedef DSPSIODeviceParamBlk *DSPSIODeviceParamBlkPtr, **DSPSIODeviceParamBlkHandle;

typedef DSPClientInfoParamBlk *DSPClientInfoParamBlkPtr, **DSPClientInfoParamBlkHandle;

typedef DSPTaskInfoParamBlk *DSPTaskInfoParamBlkPtr, **DSPTaskInfoParamBlkHandle;

typedef DSPModuleInfoParamBlk *DSPModuleInfoParamBlkPtr, **DSPModuleInfoParamBlkHandle;

typedef DSPSectionInfoParamBlk *DSPSectionInfoParamBlkPtr, **DSPSectionInfoParamBlkHandle;

typedef DSPGPBModeIndicator *DSPGPBModeIndicatorPtr, **DSPGPBModeIndicatorHandle;

#ifndef __cplusplus
typedef DSPMessage *DSPMessagePtr, **DSPMessageHandle;

#else
typedef unsigned long *DSPMessagePtr, **DSPMessageHandle;

#endif
#define _DSPDispatch 0xABF5
#define MOVEL 0x303C
#if CFMSYSTEMCALLS
#define DSPDispatch(select)
#else
#define DSPDispatch(select) = {MOVEL,select,_DSPDispatch}
#endif
#define kdspGetTrapAddress 0
#define kdspSetTrapAddress 1
#define kdspGetIndexedCPUDevice 2
#define kdspOpenCPUDevice 3
#define kdspCloseCPUDevice 4
#define kdspGetIndexedCPUDeviceOption 5
#define kdspSetIndexedCPUDeviceOption 6
#define kdspGetIndexedIODevice 7
#define kdspOpenIODevice 8
#define kdspCloseIODevice 9
#define kdspGetIndexedIODeviceOption 10
#define kdspSetIndexedIODeviceOption 11
#define kdspSignInCPUDevice 12
#define kdspSignOutCPUDevice 13
#define kdspSignInIODevice 14
#define kdspSignOutIODevice 15
#define kdspLoadModule 16
#define kdspUnloadModule 17
#define kdspConnectSections 18
#define kdspNewInterTaskBuffer 19
#define kdspNewTask 20
#define kdspDisposeTask 21
#define kdspInsertTask 22
#define kdspManagerVersion 23
#define kdspRemoveTask 24
#define kdspTaskToSynchronize 25
#define kdspAddressInZone 26
#define kdspSynchronizeTasks 27
#define kdspSetTaskActive 28
#define kdspSetTaskInactive 29
#define kdspCreateZone 30
#define kdspNewAddress 31
#define kdspDisposeAddress 32
#define kdspGetAddressSize 33
#define kdspGetZoneSize 34
#define kdspGetAddress 35
#define kdspGetZone 36
#define kdspInsertDouble 37
#define kdspRemoveDouble 38
#define kdspInsertSingle 39
#define kdspRemoveSingle 40
#define kdspGetSection 41
#define kdspNewFIFO 42
#define kdspDisposeFIFO 43
#define kdspGetSectionData 44
#define kdspFIFORead 45
#define kdspFIFOWrite 46
#define kdspFIFOGetReadCount 47
#define kdspFIFOGetWriteCount 48
#define kdspFIFOGetSize 49
#define kdspCreateModule 50
#define kdspInsertModule 51
#define kdspDisposeModule 52
#define kdspRemoveModule 53
#define kdspGetClientZone 54
#define kdspNewStorage 55
#define kdspAllocateStorage 56
#define kdspUnreserveStorage 57
#define kdspDeallocateStorage 58
#define kdspDisposeStorage 59
#define kdspProcessMessages 60
#define kdspFIFOClearInterrupt 61
#define kdspFIFOGetRefCon 62
#define kdspFIFOSetRefCon 63
#define kdspFIFOGetMessageMode 64
#define kdspFIFOSetMessageMode 65
#define kdspFIFOReset 66
#define kdspSetTaskRefCon 67
#define kdspGetTaskRefCon 68
#define kdspGetIndexedClient 69
#define kdspGetIndexedTask 70
#define kdspGetOwnerClient 71
#define kdspGetIndexedModule 72
#define kdspGetOwnerTask 73
#define kdspGetIndexedSection 74
#define kdspGetOwnerModule 75
#define kdspGetClientInfo 76
#define kdspGetTaskInfo 77
#define kdspGetModuleInfo 78
#define kdspGetSectionInfo 79
#define kdspConnectITBSections 80
#define kdspConnectTwoFIFOSections 81
#define kdspConnectFIFOToAIAOSections 82
#define kdspConnectFIFOSections 83
#define kdspConnectRegularSections 84
#define kdspAllocate 85
#define kdspUpdateCPUDeviceInfo 86
#define kdspDisposeOneFIFO 87
#define kdspFIFOSwap 88
#define kdspCountModule 89
#define kdspDontCountModule 90
#define kdspSetSkipCount 91
#define kdspGetTaskStatus 92
#define kdspSetCPUDeviceBondage 93
#define kdspFIFOGetMessageDispatch 94
#define kdspUpdateGPBPrefFile 95
#define kdspFIFOSetMessageThreshold 96
#define kdspSetGPBMode 97
#define kdspDontUpdateGPBPrefs 98
#define kdspUpdateGPBPreferenceFile 99
#define kdspConnectHIHOSections 100
#define kdspDisposeZone 101
#define kdspClientMessageDispatch 102
#define kdspFIFOGetMessageActionProc 103
#define kdspFIFOSetMessageActionProc 104
#define kdspSetSystemTask 105
#define kdspGetAvailableOnChipMemory 106
#define kdspSetSectionSize 107
#define kdspGetPtrSize 108
#define kdspAllocateDriverFIFO 109
#define kdspDisposeDriverFIFO 110
#define kdspPatchPrevAndNext 111
#define kdspSetUpLowAndHighPointerFromTask 112
#define kdspAllocateSharedSections 113
#define kdspAllocateSection 114
#define kdspAllocateModule 115
#define kdspNewStorageSection 116
#define kdspClientRefNumToDSPClientPtr 117
#define kdspGetDeviceRefNum 118
#define kdspAddClient 119
#define kdspRemoveClient 120
#define kdspGetCPUDeviceGivenIndex 121
#define kdspGetIODeviceGivenIndex 122
#define kdspUpdateIODeviceParamBlk 123
#define kdspGetTaskGivenSectionTable 124
#define kdspGetExceptionNotification 125
#define kdspCPUDeviceRefNumToDevicePtr 126
#define kdspConfigureSlaveDevice 127
#define kdspGetCPUDeviceGivenRefNum 256
#define kdspGetIODeviceGivenRefNum 257
#define kdspGetFIFOPtr 258
#define kdspGetMaxCycles 259
#define kdspGetUsedCycles 260
#define kdspCyclesInTask 261
#define kdspNewPhysicalPtr 262
#define kdspDisposePhysicalPtr 263
#define kdspVMPresent 264
#define kdspGetDSPZone 265
#define kdspComputePhysical 266
#define kdspCleanUpZone 267
#define kdspLogicalToPhysical 268
#define kdspSectionStructPtr2RefNum 269
#define kdspSectionRefNum2StructPtr 270
#define kdspAttachAddrFixups 271
#define kdspTryToCacheVanillaProgram 272
#define kdspConvertDSPFtoDSPModule 273
#define kdspGetTaskPtr 274
#define kdspGetModulePtr 275
#define kdspGetSectionPtr 276
#define kdspCheckTask 277
#define kdspPatchOneAddress 278
#define kdspPatchAllAddresses 279
#define kdspSetUpTask 280
#define kdspTaskGetMessageDispatch 281
#define kdspGetOverrunNotification 282
#define kdspCheckHIHOConnections 283
#define kdspPowerManager 284
#define kdspConvertFrameRate 285
#define kdspAllocateSegment 286
#define kdspLoadKernel 287
#define kdspConnectIndirectSections 288
#define kdspGetGPBModes 289
#define kdspDeviceCall 290
#define kdspDriverCall 291
#define kdspGetResource 292
#define kdspCreateAliasToResfile 293
#define kdspRebootCPUDevice 294
#define kdspLoadSlotDrivers 295
#define kdspGetTimeShareLoading 296
extern pascal OSErr DSPGetIndexedCPUDevice(DSPCPUDeviceParamBlkPtr theCPUParamBlk)
 THREEWORDINLINE(0x303C, 2, 0xABF5);
extern pascal OSErr DSPOpenCPUDevice(DSPCPUDeviceParamBlkPtr theCPUParamBlk)
 THREEWORDINLINE(0x303C, 3, 0xABF5);
extern pascal OSErr DSPCloseCPUDevice(DSPCPUDeviceParamBlkPtr theCPUParamBlk)
 THREEWORDINLINE(0x303C, 4, 0xABF5);
extern pascal OSErr DSPUpdateCPUDeviceInfo(DSPCPUDeviceParamBlkPtr theCPUParamBlk)
 THREEWORDINLINE(0x303C, 86, 0xABF5);
extern pascal OSErr DSPGetIndexedCPUDeviceOption(DSPCPUDeviceParamBlkPtr theCPUParamBlk, unsigned short theOptionIndex, OSType theOptionType, unsigned long *theOption)
 THREEWORDINLINE(0x303C, 5, 0xABF5);
extern pascal OSErr DSPSetIndexedCPUDeviceOption(DSPCPUDeviceParamBlkPtr theCPUParamBlk, unsigned short theOptionIndex, OSType theOptionType)
 THREEWORDINLINE(0x303C, 6, 0xABF5);
extern pascal OSErr DSPGetIndexedIODevice(DSPIODeviceParamBlkPtr theIOParamBlk)
 THREEWORDINLINE(0x303C, 7, 0xABF5);
extern pascal OSErr DSPOpenIODevice(DSPIODeviceParamBlkPtr theIOParamBlk)
 THREEWORDINLINE(0x303C, 8, 0xABF5);
extern pascal OSErr DSPCloseIODevice(DSPIODeviceParamBlkPtr theIOParamBlk)
 THREEWORDINLINE(0x303C, 9, 0xABF5);
extern pascal OSErr DSPGetIndexedIODeviceOption(DSPIODeviceParamBlkPtr theIOParamBlk, unsigned short theOptionIndex, OSType theOptionType, unsigned long *theOption)
 THREEWORDINLINE(0x303C, 10, 0xABF5);
extern pascal OSErr DSPSetIndexedIODeviceOption(DSPIODeviceParamBlkPtr theIOParamBlk, unsigned short theOptionIndex, OSType theOptionType)
 THREEWORDINLINE(0x303C, 11, 0xABF5);
extern pascal OSErr DSPLoadModule(StringPtr theName, DSPTaskRefNum theTaskRefNum, DSPPosition thePosition, DSPModuleRefNum theReferenceModuleRefNum, DSPModuleRefNum *theNewModuleRefNum, long theScale)
 THREEWORDINLINE(0x303C, 16, 0xABF5);
extern pascal OSErr DSPUnloadModule(DSPTaskRefNum theTaskRefNum, DSPModuleRefNum theModuleRefNum)
 THREEWORDINLINE(0x303C, 17, 0xABF5);
extern pascal OSErr DSPConnectSections(DSPSectionRefNum sectionOneRefNum, DSPSectionRefNum sectionTwoRefNum, DSPConnectionType theConnectionType)
 THREEWORDINLINE(0x303C, 18, 0xABF5);
extern pascal OSErr DSPNewInterTaskBuffer(DSPTaskRefNum theTaskRefNum, unsigned long theSize, unsigned short theDataType, Str31 theInterTaskBufferName, short bankPreference, DSPSectionRefNum *theReturnedSection)
 THREEWORDINLINE(0x303C, 19, 0xABF5);
extern pascal OSErr DSPNewTask(DSPCPUDeviceParamBlkPtr theCPUDevice, MessageActionProc theVector, StringPtr theTaskName, DSPTaskRefNum *theRefNum)
 THREEWORDINLINE(0x303C, 20, 0xABF5);
extern pascal OSErr DSPDisposeTask(DSPTaskRefNum theTaskRefNum)
 THREEWORDINLINE(0x303C, 21, 0xABF5);
extern pascal OSErr DSPInsertTask(DSPCPUDeviceParamBlkPtr theCPUDevice, DSPTaskRefNum theNewTaskRefNum, DSPPosition thePosition, DSPTaskPriority interruptLevel, DSPTaskRefNum theRelativeTaskRefNum)
 THREEWORDINLINE(0x303C, 22, 0xABF5);
extern pascal OSErr DSPRemoveTask(DSPTaskRefNum theTaskRefNum)
 THREEWORDINLINE(0x303C, 24, 0xABF5);
extern pascal OSErr DSPTaskToSynchronize(DSPTaskRefNum theRefNum, unsigned long frameDelay, DSPSynchRefNum *synchRefNum)
 THREEWORDINLINE(0x303C, 25, 0xABF5);
extern pascal OSErr DSPSynchronizeTasks(DSPSynchRefNum *synchRefNum)
 THREEWORDINLINE(0x303C, 27, 0xABF5);
extern pascal OSErr DSPSetTaskActive(DSPTaskRefNum theRefNum)
 THREEWORDINLINE(0x303C, 28, 0xABF5);
extern pascal OSErr DSPSetTaskInactive(DSPTaskRefNum theRefNum)
 THREEWORDINLINE(0x303C, 29, 0xABF5);
extern pascal OSErr DSPGetSection(DSPModuleRefNum theModuleRefNum, StringPtr theSectionName, DSPSectionRefNum *theSectionRefNum)
 THREEWORDINLINE(0x303C, 41, 0xABF5);
extern pascal OSErr DSPNewFIFO(DSPSectionRefNum theSectionRefNum, DSPFIFORefNum *theFIFORefNum, unsigned long theSize, Ptr logical, Ptr physical, Boolean fifoFull, MessageActionProc theInterrupt)
 THREEWORDINLINE(0x303C, 42, 0xABF5);
extern pascal OSErr DSPDisposeFIFO(DSPSectionRefNum theSectionRefNum)
 THREEWORDINLINE(0x303C, 43, 0xABF5);
extern pascal OSErr DSPGetSectionData(DSPSectionRefNum theSectionRefNum, Ptr *theData)
 THREEWORDINLINE(0x303C, 44, 0xABF5);
extern pascal unsigned long DSPFIFORead(DSPFIFORefNum theFIFORefNum, Ptr theDestination, unsigned long theCount)
 THREEWORDINLINE(0x303C, 45, 0xABF5);
extern pascal unsigned long DSPFIFOWrite(DSPFIFORefNum theFIFORefNum, Ptr theSource, unsigned long theCount)
 THREEWORDINLINE(0x303C, 46, 0xABF5);
extern pascal unsigned long DSPFIFOGetReadCount(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 47, 0xABF5);
extern pascal unsigned long DSPFIFOGetWriteCount(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 48, 0xABF5);
extern pascal unsigned long DSPFIFOGetSize(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 49, 0xABF5);
extern pascal OSErr DSPFIFOClearInterrupt(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 61, 0xABF5);
extern pascal unsigned long DSPFIFOGetRefCon(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 62, 0xABF5);
extern pascal OSErr DSPFIFOSetRefCon(DSPFIFORefNum theFIFORefNum, unsigned long theValue)
 THREEWORDINLINE(0x303C, 63, 0xABF5);
extern pascal unsigned long DSPFIFOGetMessageMode(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 64, 0xABF5);
extern pascal OSErr DSPFIFOSetMessageMode(DSPFIFORefNum theFIFORefNum, unsigned long theFlags)
 THREEWORDINLINE(0x303C, 65, 0xABF5);
extern pascal unsigned long DSPManagerVersion(void)
 THREEWORDINLINE(0x303C, 23, 0xABF5);
extern pascal OSErr DSPFIFOReset(DSPFIFORefNum theFIFORefNum)
 THREEWORDINLINE(0x303C, 66, 0xABF5);
extern pascal OSErr DSPSetTaskRefCon(DSPTaskRefNum theRefNum, unsigned long theData)
 THREEWORDINLINE(0x303C, 67, 0xABF5);
extern pascal unsigned long DSPGetTaskRefCon(DSPTaskRefNum theRefNum)
 THREEWORDINLINE(0x303C, 68, 0xABF5);
extern pascal OSErr DSPGetIndexedClient(unsigned long theIndex, DSPCPUDeviceParamBlkPtr theCPUDevice, DSPClientRefNum *theClientRefNum)
 THREEWORDINLINE(0x303C, 69, 0xABF5);
extern pascal OSErr DSPGetIndexedTask(unsigned long theIndex, DSPTaskPriority interruptLevel, DSPCPUDeviceParamBlkPtr theCPUDevice, DSPTaskRefNum *theTaskRefNum)
 THREEWORDINLINE(0x303C, 70, 0xABF5);
extern pascal OSErr DSPGetOwnerClient(DSPTaskRefNum theTaskRefNum, DSPClientRefNum *theClientRefNum)
 THREEWORDINLINE(0x303C, 71, 0xABF5);
extern pascal OSErr DSPGetIndexedModule(unsigned long theIndex, DSPTaskRefNum theTaskRefNum, DSPModuleRefNum *theModuleRefNum)
 THREEWORDINLINE(0x303C, 72, 0xABF5);
extern pascal OSErr DSPGetOwnerTask(DSPModuleRefNum theModuleRefNum, DSPTaskRefNum *theTaskRefNum)
 THREEWORDINLINE(0x303C, 73, 0xABF5);
extern pascal OSErr DSPGetIndexedSection(unsigned long theIndex, DSPModuleRefNum theModuleRefNum, DSPSectionRefNum *theSectionRefNum)
 THREEWORDINLINE(0x303C, 74, 0xABF5);
extern pascal OSErr DSPGetOwnerModule(DSPSectionRefNum theSectionRefNum, DSPModuleRefNum *theModuleRefNum)
 THREEWORDINLINE(0x303C, 75, 0xABF5);
extern pascal OSErr DSPGetClientInfo(DSPClientInfoParamBlkHandle theClientParamBlkHdl)
 THREEWORDINLINE(0x303C, 76, 0xABF5);
extern pascal OSErr DSPGetTaskInfo(DSPTaskInfoParamBlkHandle theTaskParamBlkHdl)
 THREEWORDINLINE(0x303C, 77, 0xABF5);
extern pascal OSErr DSPGetModuleInfo(DSPModuleInfoParamBlkHandle theModuleParamBlkHdl)
 THREEWORDINLINE(0x303C, 78, 0xABF5);
extern pascal OSErr DSPGetSectionInfo(DSPSectionInfoParamBlkHandle theSectionParamBlkHdl)
 THREEWORDINLINE(0x303C, 79, 0xABF5);
extern pascal OSErr DSPCountModule(DSPModuleRefNum theModuleRefNum)
 THREEWORDINLINE(0x303C, 89, 0xABF5);
extern pascal OSErr DSPDontCountModule(DSPModuleRefNum theModuleRefNum)
 THREEWORDINLINE(0x303C, 90, 0xABF5);
extern pascal OSErr DSPSetSkipCount(DSPModuleRefNum theModuleRefNum, unsigned long theCount)
 THREEWORDINLINE(0x303C, 91, 0xABF5);
extern pascal DSPTaskStatus DSPGetTaskStatus(DSPTaskRefNum theRefNum)
 THREEWORDINLINE(0x303C, 92, 0xABF5);
extern pascal OSErr DSPSetCPUDeviceBondage(DSPCPUDeviceParamBlkPtr cpuDevice1, DSPCPUDeviceParamBlkPtr cpuDevice2)
 THREEWORDINLINE(0x303C, 93, 0xABF5);
extern pascal OSErr DSPFIFOSetMessageThreshold(DSPFIFORefNum theFIFORefNum, unsigned long theThreshold)
 THREEWORDINLINE(0x303C, 96, 0xABF5);
extern pascal OSErr DSPFIFOSwap(DSPFIFORefNum theFIFORefNum, unsigned long theSize, Ptr logical, Ptr physical, Boolean fifoFull, MessageActionProc theInterrupt)
 THREEWORDINLINE(0x303C, 88, 0xABF5);
extern pascal OSErr DSPSetGPBMode(DSPModuleRefNum theModuleRefNum, unsigned short desiredMode)
 THREEWORDINLINE(0x303C, 97, 0xABF5);
extern pascal OSErr DSPDontUpdateGPBPrefs(DSPModuleRefNum theModuleRefNum)
 THREEWORDINLINE(0x303C, 98, 0xABF5);
extern pascal OSErr DSPUpdateGPBPreferenceFile(DSPModuleRefNum theModuleRefNum)
 THREEWORDINLINE(0x303C, 99, 0xABF5);
extern pascal OSErr DSPFIFOGetMessageActionProc(DSPFIFORefNum theFIFORefNum, MessageActionProc *theVector)
 THREEWORDINLINE(0x303C, 103, 0xABF5);
extern pascal OSErr DSPFIFOSetMessageActionProc(DSPFIFORefNum theFIFORefNum, MessageActionProc theVector)
 THREEWORDINLINE(0x303C, 104, 0xABF5);
extern pascal OSErr DSPGetAvailableOnChipMemory(DSPModuleRefNum theModuleRefNum, unsigned long *theSize)
 THREEWORDINLINE(0x303C, 106, 0xABF5);
extern pascal OSErr DSPSetSectionSize(DSPSectionRefNum theSectionRefNum, unsigned long theSize)
 THREEWORDINLINE(0x303C, 107, 0xABF5);

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __DSPMANAGER__ */
