/*
 	File:		Finder.h
 
 	Contains:	Finder flags and container types
 
 	Version:	Technology:	
 				Package:	Universal Interfaces  DDK v23c5.  Monday, May 15, 1995.
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Bugs?:		If you find a problem with this file, use the Apple Bug Reporter
 				stack.  Include the file and version information (from above)
 				in the problem description and send to:
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
*/

#ifndef __FINDER__
#define __FINDER__


#ifdef __cplusplus
extern "C" {
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=mac68k
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif


enum {
/* Make only the following consts avaiable to resource files that include this file */
	kCustomIconResource			= -16455,						/* Custom icon family resource ID */
	kContainerFolderAliasType	= 'fdrp',						/* type for folder aliases */
	kContainerTrashAliasType	= 'trsh',						/* type for trash folder aliases */
	kContainerHardDiskAliasType	= 'hdsk',						/* type for hard disk aliases */
	kContainerFloppyAliasType	= 'flpy',						/* type for floppy aliases */
	kContainerServerAliasType	= 'srvr',						/* type for server aliases */
	kApplicationAliasType		= 'adrp',						/* type for application aliases */
	kContainerAliasType			= 'drop',						/* type for all other containers */
/* types for Special folder aliases */
	kSystemFolderAliasType		= 'fasy',
	kAppleMenuFolderAliasType	= 'faam',
	kStartupFolderAliasType		= 'fast',
	kPrintMonitorDocsFolderAliasType = 'fapn',
	kPreferencesFolderAliasType	= 'fapf',
	kControlPanelFolderAliasType = 'fact',
	kExtensionFolderAliasType	= 'faex',
/* types for AppleShare folder aliases */
	kExportedFolderAliasType	= 'faet',
	kDropFolderAliasType		= 'fadr',
	kSharedFolderAliasType		= 'fash',
	kMountedFolderAliasType		= 'famn'
};

enum {
/* Finder Flags */
	kIsOnDesk					= 0x1,
	kColor						= 0xE,
	kIsShared					= 0x40,
	kHasBeenInited				= 0x100,
	kHasCustomIcon				= 0x400,
	kIsStationery				= 0x800,
	kIsStationary				= 0x800,
	kNameLocked					= 0x1000,
	kHasBundle					= 0x2000,
	kIsInvisible				= 0x4000,
	kIsAlias					= 0x8000
};


#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __FINDER__ */
