/************************************************************

	Assert.h
	Diagnostics
	
	Copyright  Apple Computer,Inc.  1987-1990, 1994.
	All Rights Reserved.

************************************************************/

#ifndef __ASSERT__
#define	__ASSERT__

#ifdef NDEBUG
	#undef assert
	#define assert(ignore) ((void) 0)
#else

	#ifdef __CFM68K__
		#ifdef UsingSharedLibs
			#pragma lib_export on
		#endif
	#endif
	#ifdef __cplusplus
		extern "C" {
	#endif
	void __assertprint(const char* file, int line, const char* expr);
	#ifdef __cplusplus
		}
	#endif
	#ifdef __CFM68K__
		#ifdef UsingSharedLibs
			#pragma lib_export on
		#endif
	#endif
	
	#define assert(expression) \
		( (expression) ? (void) 0 : (__assertprint(__FILE__, __LINE__, #expression)) )
			
#endif

#endif
