/*
	File:		ResourceTemplate.r

	Contains:	Standard version resource for Shared Library Manager

	Written by:	

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):


*/



#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

/* #include "DLPIVersionNumber.h" */

#define VMajor			1
#define VMinor			(1 * 16)+0
#define VStage			release
#define VRelease		0
#define VShortString	"1.0b7"
#define VLongString		"1.0b7, ABC Vendor, Inc. 199x"

resource 'vers' (1) {
	VMajor, VMinor, VStage, VRelease, verUS,
	VShortString,
	VLongString
};

resource 'cfrg' (0) {
   {
      kPowerPC,				/* Target machine's Architecture. */
      kFullLib,				/* This is not an update. */
	  kNoVersionNum,		/* Current version. */
	  kNoVersionNum,		/* Definition version. */
	  kDefaultStackSize,	/* Stack size of application. */
	  kNoAppSubFolder,		/* Not used here.  Can be the resource-id of an 'alis'
	                           resource.  Used to provide additional location
							   to search for libraries. */
	  kIsLib,				/* This is library. */
	  kOnDiskFlat,          /* This code fragment is on disk, in the data fork. */
	  kZeroOffset,		    /* Offset of code into data fork. */
	  kWholeFork,           /* Code takes up all of data fork (can give a size). */
	  "ABCVendorDLPI"       /* Name of library., what does this name mean? */
   }
};

