#############################################################################
#
#	Contains:	Builds a CFM shared library which is a DLPI.  Please read
#				the build instructions file in order to setup certain
#				MPW variables which are necessary for this makefile.
#
#	Written by:	
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#
#
#############################################################################

DLPISRC 	= :::Common Source:
OBJ			= ::Objects:
BLT			= ::Built:

#
#	OTDevTools should point to the Open Transport SDK Folder
#

OTClientIncludes	= {OTDevTools}Open Tpt Client Developer:Includes:CIncludes:				
OTModuleIncludes	= {OTDevTools}Open Tpt Module Developer:Includes:
OTModuleLibraries	= {OTDevTools}Open Tpt Module Developer:Libraries:


MakeFile = dlpiCFM.make
LibName = "ABCVendorDLPI"
Lib_Type = 'ndrv'
Lib_Creator = 'cfrg'
Lib_Objects = 					
		"{OBJ}"EntryPoints.c.o 	
		"{OBJ}"DLPIRoutines.c.o 
		"{OBJ}"PCIRoutines.c.o 
		"{OBJ}"HWSpecific.c.o
		
Lib_Resources = "{DLPISRC}ResourceTemplate.r"

#
#	External Libraries
#

PPC_Sys_Libraries = 
					#"{PPCLibraries}"InterfaceLib.xcoff 		
				    #"{PPCLibraries}"StdCLib.xcoff 				
				    #"{PPCLibraries}"StdCRuntime.o 				
				    "{PPCLibraries}"PPCCRuntime.o 				
					"{OTModuleLibraries}OpenTptModuleLib"		
					"{DriverLibraries}"DriverServicesLib		
					"{DriverLibraries}"NameRegistryLib			
					"{DriverLibraries}"PCILib

#
#	C Files
#

.c.o  .c {MakeFile} "{DLPISRC}"HWSpecific.h "{DLPISRC}"DLPIRoutines.h "{DLPISRC}"PCIRoutines.h
	 PPCC  -appleext on {PPCC_Options} {DepDir}{Default}.c -o {Targ}
#	 mrc {PPCC_Options} {DepDir}{Default}.c -o {Targ}

#
#	OPTIONS
#

SymOpt  				= ON

PPCC_Options = -sym {SymOpt} -opt off	
				-shared_lib_export on 				
				-export_list {OBJ}NotUsedExportList	
			   	-i "{OTModuleIncludes}" 			
			   	-i "{OTClientIncludes}" 			
			   	-i "{DriverHeaders}" 				
				-i "{CIncludes}"	

PPCLink_Options = -sym {SymOpt} -xm s -outputformat pef


#
#	DEPENDENCIES
#

"{OBJ}"			 	"{DLPISRC}"

dlpiCFM			 	{BLT}{LibName} 

#
#	CREATE LIBRARY
#

{BLT}{LibName}   {Lib_Objects}
	PPCLink {PPCLink_Options}  
			-init InitCFMRoutine	
			-term TerminateCFMRoutine	
			-export TheDriverDescription 
			-export InitStreamModule 
			-export TerminateStreamModule 
			-export	GetOTInstallInfo 
			-export	ValidateHardware 
		    {Lib_Objects} 
		    {PPC_Sys_Libraries} 
		    -t {Lib_Type} 
			-c {Lib_Creator} 
		    -o {BLT}{LibName}
	Rez 	-t {Lib_Type} -c {Lib_Creator} 
			{Lib_Resources} -a -o {BLT}{LibName}
	SetFile {BLT}{LibName} -a ib
	echo "Done building the DLPI"


