/*								NCRSCSIDriver.r								*/
/*
 * NCRSCSIDriver.r
 * Copyright  1994, Apple Computer Inc. All Rights reserved.
 */
#ifndef MPW
#define MPW					0
#endif

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"
#include "NCRDriverPrivate.h"
include "NCRDriverIcons.rsrc";

resource 'vers' (1) {
	kVersionMajor, kVersionMinor, kVersionStage, kVersionRevision, verUS,
	$$format(
		"%d.%d%s%d (%4d.%02.%02d)",
		kVersionMajor, kVersionMinor, kVersionStageName, kVersionRevision,
		$$year, $$month, $$day
	),
	$$format(
		"%d.%d%s%d  1992-%4d Apple Computer Inc. All Rights Reserved",
		kVersionMajor, kVersionMinor, kVersionStageName, kVersionRevision,
		$$year
	),
};

#if MPW
/*
 * Define the Code Fragment resource for MPW -- MetroWerks provides
 * its own definition.
 */
resource 'cfrg' (0) {
	{
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"NCRDriver"
	}
};
#endif

/*
 * The 'sysz' resource extends the system heap at startup, leaving
 * room for the data needed by this System Extension.
 */
type 'sysz' {
	longint;
};
resource 'sysz' (0, "256 Kb") {
	256 * 1024 			/* 1/4 Mb of system heap			*/
};
		
		

