#############################################################################
#
#	Contains:	Builds a CFM shared library which is an ATM PCI DLPI. Please read
#				the build instructions file in order to setup certain
#				MPW variables which are necessary for this makefile.
#
#	Written by:	
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#
#
#############################################################################

DLPISRC 	= :::Sources:
OBJ			= ::Objects:
BLT			= ::Built:

#
#	OTDevTools should point to the Open Transport SDK Folder
#

OTClientIncludes	= {OTDevTools}Open Tpt Client Developer:Includes:CIncludes:				
OTModuleIncludes	= {OTDevTools}Open Tpt Module Developer:Includes:
OTModuleLibraries	= {OTDevTools}Open Tpt Module Developer:Libraries:

MakeFile = atmdlpiCFM.make
LibName = "ABCVendorATMDLPI"
Lib_Type = 'ndrv'
Lib_Creator = 'cfrg'
Lib_Objects = 					
		"{OBJ}"ATMDLPI.c.o 		
		"{OBJ}"PCIRoutines.c.o	
		"{OBJ}"HWSpecific.c.o
		
Lib_Resources = "{DLPISRC}ResourceTemplate.r"

#
#	External Libraries
#

PPC_Sys_Libraries = 
					"{PPCLibraries}"InterfaceLib.xcoff 			
				    "{PPCLibraries}"StdCLib.xcoff 				
				    "{PPCLibraries}"StdCRuntime.o 				
				    "{PPCLibraries}"PPCCRuntime.o 				
					"{OTModuleLibraries}OpenTptModuleLib"		
					"{DriverLibraries}"DriverServicesLib		
					"{DriverLibraries}"NameRegistryLib			
					"{DriverLibraries}"PCILib

PPC_Lib_Equates = 
					-librename InterfaceLib.xcoff=InterfaceLib 
				 	-librename StdCLib.xcoff=StdCLib

#
#	Export values for CFM
#

DriverDescHeader 		= TheDriverDescription				

OTInitModule			= InitStreamModule					
OTTerminateModule		= TerminateStreamModule
OTInstallInfo		 	= GetOTInstallInfo
OTInitHardware			= ValidateHardware

CFMInitRoutine			= InitCFMRoutine
CFMTerminateRoutine		= TerminateCFMRoutine

#
#	C Files
#

.c.o  .c {MakeFile} "{DLPISRC}"ATMDLPI.h "{DLPISRC}"HWSpecific.h "{DLPISRC}"PCIRoutines.h
	 MrC {MrC_Options}  {DepDir}{Default}.c -o {Targ}

#
#	OPTIONS
#

SymOpt  				= on
PPCCOpt 				= off

MrC_Options =	-sym {SymOpt} -opt {PPCCOpt} -shared_lib_export on 
				-D NoASM -D RS6000=0 -D powerpc=1 -D interface_glue 
				-d ATM_DEBUG -d LOOPBACK_TEST 
				-export_list {OBJ}NotUsedExportList	
			   	-i "{OTModuleIncludes}" 			
			   	-i "{OTClientIncludes}" 			
			   	-i "{DriverHeaders}" 				
				-i "{CIncludes}"					
				-i "{ATMHeaders}"

PPCLink_Options = -sym {SymOpt} -xm s -outputformat xcoff


#
#	DEPENDENCIES
#

"{OBJ}"			 	"{DLPISRC}"

atmdlpiCFM			 	{BLT}{LibName} 

#
#	CREATE LIBRARY
#

{BLT}{LibName}  {OBJ}{LibName}.xcoff
	MakePEF {Deps} -o {BLT}{LibName} 
			-i {CFMInitRoutine}	
			-t {CFMTerminateRoutine}	
	        {PPC_Lib_Equates} 
		    -ft {Lib_Type} -fc {Lib_Creator}

{OBJ}{LibName}.xcoff   {Lib_Objects}
	PPCLink {PPCLink_Options}  
			-export {DriverDescHeader} 
			-export {OTInitModule} 
			-export {OTTerminateModule} 
			-export	{OTInstallInfo} 
			-export	{OTInitHardware} 
			-export	{CFMInitRoutine} 
			-export {CFMTerminateRoutine} 
		    {Lib_Objects} 
		    {PPC_Sys_Libraries} 
		    -o {OBJ}{LibName}.xcoff
	If "{SymOpt}" =~ /[oO][nN]/
   	MakeSYM {OBJ}{LibName}.xcoff -i {DLPISRC} -w -o {OBJ}{LibName}.xSYM
	End

{BLT}{LibName}  {Lib_Resources} {MakeFile}
	Rez 	-t {Lib_Type} -c {Lib_Creator} 
			{Lib_Resources} -a -o {BLT}{LibName}
	SetFile {BLT}{LibName} -a ib
	echo "Done building the DLPI"
