/***********************************************************
	File:		HWSpecific.h

	Contains:	ATM PCI hardware specific code header
	
	Written by:	

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):
	
	To Do:
 ***********************************************************/

/***********************************************************
  INCLUDES
 ***********************************************************/

#include <OpenTptModule.h>
#include <OpenTptDevLinks.h>

#include <Interrupts.h>
#include <PCI.h>
#include <OSUtils.h>
#include <Kernel.h>
#include <DriverServices.h>
#include <Devices.h>
#include <CodeFragments.h>

#include "ATMDLPI.h"

/***********************************************************
  DEFINES
 ***********************************************************/

#define kPCIDeviceInfoName		"\ppci2108,0"	// pascal string,vendor ID & device id
#define kModuleDeviceInfoName	"pci2108,0"		// c string, vendor ID & device id
//#define kPCIDeviceInfoName		"\ppci1234,5678"	// pascal string,vendor ID & device id
//#define kModuleDeviceInfoName	"pci1234,5678"		// c string, vendor ID & device id

/* Maximum/Minimum PDU sizes */
#define kMaxAAL5PDU 65535
#define kMinAAL5PDU 1

#define kTrue					1
#define kFalse					0

/***********************************************************
  STRUCTS AND TYPEDEFS
 ***********************************************************/

struct _ABCVendorCardSpecific {
	UInt32				cardBaseAddr;		// only necessary for memory mapped cards
};

typedef struct _ABCVendorCardSpecific ABCVendorCardSpecific;

/***********************************************************
  EXTERNS
 ***********************************************************/

extern Boolean ABCVendorIsThisOurCard(RegEntryID *theID, UInt32 cardAddress);
extern Boolean ABCVendorInit(RegEntryID *theID);
extern void ABCVendorTerminate(void);
extern SInt32 ABCVendorSetATMAddress(UInt8 *physicalAddress);
extern void ABCVendorGetFactoryATMAddress(UInt8 *addressArray);
extern UInt32 ABCVendorGetPeakCellRate();
extern OSStatus ABCVendorTransmit(ConnectTableEntry* conn, UInt16 vpi, UInt16 vci, mblk_t* mp);
extern OSStatus ABCVendorActivateVCI(ConnectTableEntry* conn);
extern OSStatus ABCVendorDeactivateVCI(ConnectTableEntry* conn);
extern InterruptMemberNumber ABCVendorISR(InterruptSetMember member, void *refCon, UInt32 theIntCount);
